// tabdlg.cpp : Defines tab display routines for a WinHelp contents tab
//

#include "stdafx.h"
#include "filedir.h"
#include "tabdlg.h"


HWND __declspec(dllexport) WINAPI OpenTabDialog(HWND hwnd, DWORD dw1, DWORD dw2)
{
	CWinApp* theApp = AfxGetApp();
	HINSTANCE dllInstance = theApp->m_hInstance;
	HWND dHandle;
	
	//This is just a message box I use for testing
	//char test[256];      
	//int success;
	//HWND hWnd;           
	//hWnd = GetActiveWindow( );
	//success = wsprintf(test, "%d", dHandle); //Convert from LPSTR if needed
	//MessageBox( hWnd, "1", "testing dialog box", MB_OK | MB_ICONSTOP );  //The message box

	dHandle = CreateDialog(dllInstance, MAKEINTRESOURCE(IDD_DIALOG1), hwnd, TabDialogProc);
	return dHandle;
}


BOOL WINAPI TabDialogProc(HWND hdlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
	int i, id;
	LPARAM textLoc = 0;
	char lpszBuf[256];
	int success;
	char retval[256];

	CWinApp* theApp = AfxGetApp();
	HINSTANCE dllInstance = theApp->m_hInstance;

	static char TabINI[256];
	static char NameOnly[128];

	switch (msg)
	{
		case WM_INITDIALOG:
			//Get the name of the DAT file for this tab. This is the
			//name of the DLL, except with a DAT extension.
			success = GetModuleFileName(dllInstance, retval, 256);
			if (success = 0)
			{
				return 0;   //Quit if can't find file name.
			}
			success = ChangeExtension(retval, "ini", TabINI);
			success = GetNameOnly(retval, NameOnly);
	
				//This is just a message box I use for testing
				//char test[256];
				//int success;
				//HWND hWnd;           
				//hWnd = GetActiveWindow( );
				//success = wsprintf(test, "%s", TabINI); //Convert from LPSTR if needed
				//MessageBox( hdlg, TabINI, "testing tab", MB_OK | MB_ICONSTOP );  //The message box
				//MessageBox( hdlg, NameOnly, "testing tab", MB_OK | MB_ICONSTOP );  //The message box

			FILE *ReadContents;
			
			//Open the tab data file.
			if ((ReadContents = fopen (TabINI, "rt")) == NULL)
			{
				return FALSE;   //Quit if can't open file.
			}

			//Read the first line.
			//This is a section name, to be ignored now and used later.
			if (fgets(retval, 256, ReadContents) == NULL)
			{
				return FALSE;   //Quit if no first line
			}
			else
			{
				//Read lines one at a time.
				while (fgets(retval, 256, ReadContents) != NULL)
				{
					int  ch = 61;
					LPSTR pdest;
					
					//Get rid of everything after the equal sign.
					pdest = strrchr( retval, ch );  //Does entry have an equal sign?
 					if( pdest != NULL )	  //Equal sign found.
					{
    					*(pdest) = '\0';   //Write NULL to character to replace dot (strip all after equal sign)
						//Then write the string into the list box
						id=SendDlgItemMessage(hdlg, IDC_LIST1, LB_ADDSTRING, 0, (LPARAM)retval);
					}
					//Entry is ignored if no equal sign.
				}
				ShowWindow(hdlg, SW_SHOW);
				return TRUE;
			}
			

		case WM_COMMAND:
	
			if (wParam==IDOK||HIWORD(wParam)==LBN_DBLCLK)
			{
				id = SendDlgItemMessage(hdlg, IDC_LIST1, LB_GETCURSEL, 0, 0);
				
				if (id != LB_ERR)
				{
					i = SendDlgItemMessage(hdlg, IDC_LIST1, LB_GETTEXT, id, (LPARAM)lpszBuf);

					success = GetPrivateProfileString(NameOnly, lpszBuf, "", retval, 256, TabINI);

					//char test[256];      
					//int success;
					//HWND hWnd;           
					//hWnd = GetActiveWindow( );
					//success = wsprintf(test, "%d", id); //Convert from LPSTR if needed
					MessageBox( hdlg, retval, "Opening File", MB_OK | MB_ICONINFORMATION );  //The message box

					//Code to implement a help macro. This code assumes that the entry
					//is the exact help macro that you want the help file to run.
					//success=SendMessage(GetParent(hdlg), MSG_TAB_MACRO, 0, (LPARAM)retval);
					
					//Code to implement a fileopen. This code assumes that the entry
					//is the name of a file that has an association.
					//success=WinExec(retval, SW_SHOW);
					
					//Uncomment this to close the help contents tab upon selection of
					//an item in the tab.
					//success=SendMessage(GetParent(hdlg), WM_CLOSE, 0, 0);					//This is just a message box I use for testing

				}
			}
			break;

		default:
			return 0;
	}
	return 0;
}
